#include "ItemAddon.h"
#include "Net/UnrealNetwork.h"

class ADBDPlayer;

void UItemAddon::OnRep_TokenCount(int32 oldCount)
{

}

void UItemAddon::OnRep_BaseItem()
{

}

void UItemAddon::OnRep_AddonInitializationData()
{

}

bool UItemAddon::IsSecondaryAction() const
{
	return false;
}

bool UItemAddon::IsReadyForSetUp_Implementation() const
{
	return false;
}

int32 UItemAddon::GetTokenCount() const
{
	return 0;
}

int32 UItemAddon::GetMaxTokenCount() const
{
	return 0;
}

void UItemAddon::Authority_SetTokenCount(int32 value)
{

}

void UItemAddon::Authority_SetMaxTokenCount(int32 value)
{

}

void UItemAddon::Authority_OnCollectablePickedUp_Implementation(ADBDPlayer* player)
{

}

void UItemAddon::Authority_OnCollectableDropped_Implementation(ADBDPlayer* player)
{

}

void UItemAddon::Authority_IncrementToken()
{

}

void UItemAddon::Authority_DecrementToken()
{

}

void UItemAddon::Authority_ApplyMetaModifiers()
{

}

void UItemAddon::GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const
{
	Super::GetLifetimeReplicatedProps(OutLifetimeProps);

	DOREPLIFETIME(UItemAddon, _maxTokenCount);
	DOREPLIFETIME(UItemAddon, _tokenCount);
	DOREPLIFETIME(UItemAddon, _addonInitializationData);
	DOREPLIFETIME(UItemAddon, _baseItem);
}

UItemAddon::UItemAddon()
{
	this->BaseItemType = NULL;
	this->_needsSetup = false;
	this->_maxTokenCount = 3;
	this->_tokenCount = 0;
}
